/*-------------------------------------------------------------
  module: faccauchyNTL_zzpX.C
  author: Erich Kaltofen

  date: Feb 2, 1998

  description: 

  arguments:

  (c) Copyright 1996 Angel Diaz and Erich Kaltofen, All Rights Reserved
  This code is provided WITHOUT WARRANTY either expressed or implied.
 
-------------------------------------------------------------*/

#include "PlugIns/ntl2.0.h"
#include "BlackBox/CommonObjects/bbcauchy.h"
#include "BlackBox/Algorithms/bbnumden.h"
#include "BlackBox/Aux/bbselector.h"
#include "BlackBox/Aux/bbvector.h"
#include "BlackBox/Algorithms/bbsparse.h"
#include "BlackBox/Algorithms/bbfactors.h"
#include "BlackBox/Aux/bbtime.h"

typedef BlackBoxCauchyDet< NTLzz_p >                         BBCauchyNTLzz_p;
typedef BlackBoxNumDen< NTLzz_p, NTLzz_pX, BBCauchyNTLzz_p > BBNumDen;
typedef BlackBoxSelector< NTLzz_p, BBNumDen >                BBSelNumDenNTLzz_p;
typedef BlackBoxFactors< NTLzz_p, NTLzz_pX, 
        BBSelNumDenNTLzz_p >                                 BBFactors;
typedef BlackBoxSelector< NTLzz_p, BBFactors >               BBSelFactor;

int main( int argc, char *argv[] ) 
{
   int    N,F,Seed,DegDet,DegNum,DegDen,DegFac,i,IsRestart;
   double Prob;
   MP_INT MPCard;
   mpz_init_set_ui( &MPCard, 100000007 ); 
   // mpz_init_set_str( &MPCard, "10000000000000061", 10 );
   char   ProbName[BBDEFS_FILEZ];

   NTLInitEnv( &MPCard );

   if ( argc < 4 ) {
      cerr << "usage: faccauchysacZPX num_vars factor restart" << endl;
      exit( -1 );
   }

   DegDet    = -1;
   DegNum    = 200000;
   DegDen    = 200000;
   Prob      = 1.0;
   Seed      = 1;
   N         = atoi( argv[1] );
   F         = atoi( argv[2] );
   IsRestart = atoi( argv[3] );
   sprintf( ProbName, "%dx%d%s", N/2, N/2, "faccauchyshoupZPX" );
   GetCPUTime( ProbName );

   BBCauchyNTLzz_p    CNTLzz_p( N, DegDet, Prob );
   BBNumDen           NumDenCNTLzz_p( CNTLzz_p, &MPCard, DegNum, Prob, Seed );
   BBSelNumDenNTLzz_p NumNTLzz_p( NumDenCNTLzz_p, 0 );

   BBFactors        FactorsNumNTLzz_p( NumNTLzz_p, Prob, Seed, &MPCard );
   BBSelFactor      FirstFacZP( FactorsNumNTLzz_p, F );

   BBSPARSEAUX_VarVector Vars;
   BBSPARSEAUX_DegVector Degs;
   for( i=0; i<N; i++ ) Vars.push_back(i); 
   for( i=0; i<N; i++ ) Degs.push_back(1); 
   NTLzz_pX NTLzz_pXElm[BBSPARSEAUX_MAXTERMS];
   BBSPARSEAUX_VecDegVector PruneDegs;
   bbvector< NTLzz_p >     PruneMons;

   DegFac = 1;
   SparseInterp( FirstFacZP, Vars, Degs, DegFac, &MPCard, 
                 PruneDegs, PruneMons, NTLzz_pXElm, ProbName, IsRestart );

   PrintMaple( Vars, PruneDegs, PruneMons);

   mpz_clear( &MPCard );

   NTLCleanUpEnv();
   GetCPUTime( ProbName );
}

