/*-------------------------------------------------------------
  module: ratfunc.C
  author: Angel L. Diaz
  date: 8/14/96

  Test the black box ratfuncnomial classes and its sub components.
-------------------------------------------------------------*/

// arithmetic includes
#include "PlugIns/saclib.h"
#include "BlackBox/CommonObjects/bbratfunc.h"

SaclibQ p1( SaclibQ *); 

int main() {
   Word stack;
   SaclibInitEnv(1000000,stack);

   unsigned int NumVars = 2;
   unsigned int Deg = 2;
   unsigned int Prob = 1;
   SaclibQ Elm[2] = { (long)2, (long) 3 };

   BlackBoxURatFunc< SaclibQ > BBURatFunc1( p1, NumVars, Deg, Prob );
   cout << "ratfunc  : BBURatFunc1.Deg() = " << BBURatFunc1.Deg() << endl;
   cout << "ratfunc  : BBURatFunc1.NumVars() = "<<BBURatFunc1.NumVars()<< endl;
   cout << "ratfunc  : BBURatFunc1.Prob() = " << BBURatFunc1.Prob() << endl;
   cout << "ratfunc  : BBURatFunc1( Elm ) = " << *BBURatFunc1( Elm ) << endl;

   SaclibCleanUpEnv();
}

// p1 := X^2/Y^2
SaclibQ p1(
   SaclibQ* Pnts_i
   ) 
{
   SaclibQ X,Y;
   X = Pnts_i[0];
   Y = Pnts_i[1];
   return ( (X*X) / (Y*Y) );
}

