
/*-------------------------------------------------------------
  module: bbservertrace.h
  author: Angel L. Diaz

  date: 11/14/96

  desciption: 
     Tracing routines for: bbserver.C
 
     PRINTLEVEL = 0 ; tracing off
     PRINTLEVEL > 0 ; function tags
     PRINTLEVEL > 1 ; milestone messages
     PRINTLEVEL > 2 ; state variables
     PRINTLEVEL > 3 ; state variables and arrays/vectors

  (c) Copyright 1996 Angel Diaz and Erich Kaltofen, All Rights Reserved
  This code is provided WITHOUT WARRANTY either expressed or implied.

-------------------------------------------------------------*/

#ifndef _BBSERVERTRACE
#define _BBSERVERTRACE

#ifdef BBDEFS_SERVER_TRC

#include "BlackBox/Aux/bbtrace.h"

void BBSERVERTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : Waiting for a connection ..." << endl;
   }
}

void BBSERVERTrace2( 
   int Request_i
   ) 
{
   if ( PRINTLEVEL > 3 ) {
   OutputSingleItem("bbserver : ", "Request ID = ", Request_i);
   }
}

void BBSERVERTrace3( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : Waiting for a request ..." << endl;
   }
}

void BBSERVERVandTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleVand : Requesting BBNET_VAND " << endl;
   }
}

void BBSERVERVandTrace2( 
   int    Field_i,
   int    N_i,
   int    DegDet_i,
   double Prob_i
   ) 
{
   if ( PRINTLEVEL > 3 ) {
   OutputSingleItem("bbserver : HandleVand : ", "Field = ", Field_i);
   OutputSingleItem("bbserver : HandleVand : ", "N = ", N_i);
   OutputSingleItem("bbserver : HandleVand : ", "DegDet = ", DegDet_i);
   OutputSingleItem("bbserver : HandleVand : ", "Prob = ", Prob_i);
   }
}

void BBSERVERVandSTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleVandShift : Requesting BBNET_VANDSHIFT " 
        << endl;
   }
}

void BBSERVERVandSTrace2( 
   int    Field_i,
   int    N_i,
   int    DegDet_i,
   double Prob_i
   ) 
{
   if ( PRINTLEVEL > 3 ) {
   OutputSingleItem("bbserver : HandleVandShift : ", "Field = ", Field_i);
   OutputSingleItem("bbserver : HandleVandShift : ", "N = ", N_i);
   OutputSingleItem("bbserver : HandleVandShift : ", "DegDet = ", DegDet_i);
   OutputSingleItem("bbserver : HandleVandShift : ", "Prob = ", Prob_i);
   }
}

void BBSERVERGCDTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleGCD : Requesting BBNET_GCD " 
        << endl;
   }
}

void BBSERVERGCDTrace2( 
   int     r_i,
   int*    IndexArray_i,
   int     Field_i,
   MP_INT* Card_i,
   double  Prob_i,
   int     Seed_i
   ) 
{
   if ( PRINTLEVEL > 3 ) {
   OutputSingleItem("bbserver : HandleVandGCD : ", "r = ", r_i);
   OutputArray("bbserver : HandleVandGCD : ","Index of each input black box",
               "IndexAray[",IndexArray_i,0,r_i);
   OutputSingleItem("bbserver : HandleVandGCD : ", "Field = ", Field_i);
   cout << "bbserver : HandleVandGCD : Card = "; 
   mpz_out_str(stdout, 10, Card_i); cout << endl;
   OutputSingleItem("bbserver : HandleVandGCD : ", "Prob = ", Prob_i);
   OutputSingleItem("bbserver : HandleVandGCD : ", "Seed = ", Seed_i);
   }
}

void BBSERVERGCDEvalTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleGCDEval : Requesting BBNET_GCD_EVAL " 
        << endl;
   }
}

template < class K >
void BBSERVERGCDEvalTrace2(
   int Index_i,
   int Field_i,
   int NumPnts_i,
   K*  PntArray_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleVandGCDEval : ", "Index = ", Index_i);
   OutputSingleItem("bbserver : HandleVandGCDEval : ", "Field = ", Field_i);
   OutputSingleItem("bbserver : HandleVandGCDEval : ", "NumPnts = ",NumPnts_i);
   OutputArray("bbserver : HandleVandGCDEval : ","Input Points",
               "Pnts[",PntArray_i,0,NumPnts_i);
   }
}

void BBSERVERGCDEvalTrace3(
   char* Value_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleVandGCDEval : ", "Value = ", Value_i);
   }
}

void BBSERVERSetPrimeTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleSetPrime : Requesting BBNET_SETPRIME " 
        << endl;
   }
}

void BBSERVERSetPrimeTrace2( 
   char* Prime_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleSetPrime : ", "Prime = ", Prime_i);
   }
}

void BBHouseGetHandleZPXTrace1( 
   int    Index_i,
   int    IndexType_i
   ) 
{
   if ( PRINTLEVEL > 3 ) {
   cout << "bbserver : GetHandleZPX : Error, invalid index!" << endl;
   OutputSingleItem("bbserver : GetHandleZPX : ", "Index = ", Index_i);
   OutputSingleItem("bbserver : GetHandleZPX : ", "IndexType = ", 
      IndexType_i);
   }
}

void BBHouseGetHandleQXTrace1( 
   int    Index_i,
   int    IndexType_i
   ) 
{
   if ( PRINTLEVEL > 3 ) {
   cout << "bbserver : GetHandleQX : Error, invalid index!" << endl;
   OutputSingleItem("bbserver : GetHandleQX : ", "Index = ", Index_i);
   OutputSingleItem("bbserver : GetHandleQX : ", "IndexType = ", 
      IndexType_i);
   }
}

void BBSERVERToeTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleToe : Requesting BBNET_TOE" << endl;
   }
}

void BBSERVERToeTrace2( 
   int    Field_i,
   int    N_i,
   int    DegDet_i,
   double Prob_i
   ) 
{
   if ( PRINTLEVEL > 3 ) {
   OutputSingleItem("bbserver : HandleToe : ", "Field = ", Field_i);
   OutputSingleItem("bbserver : HandleToe : ", "N = ", N_i);
   OutputSingleItem("bbserver : HandleToe : ", "DegDet = ", DegDet_i);
   OutputSingleItem("bbserver : HandleToe : ", "Prob = ", Prob_i);
   }
}

void BBSERVERFacTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleFac : Requesting BBNET_FAC " 
        << endl;
   }
}

void BBSERVERFacTrace2( 
   int     BoxIndex_i,
   int     FacIndex_i,
   int     Field_i,
   MP_INT* Card_i,
   double  Prob_i,
   int     Seed_i
   ) 
{
   if ( PRINTLEVEL > 3 ) {
   OutputSingleItem("bbserver : HandleFac : ", "BoxIndex = ", BoxIndex_i);
   OutputSingleItem("bbserver : HandleFac : ", "FacIndex = ", FacIndex_i);
   OutputSingleItem("bbserver : HandleFac : ", "Field = ", Field_i);
   cout << "bbserver : HandleFac : Card = "; 
   mpz_out_str(stdout, 10, Card_i); cout << endl;
   OutputSingleItem("bbserver : HandleFac : ", "Prob = ", Prob_i);
   OutputSingleItem("bbserver : HandleFac : ", "Seed = ", Seed_i);
   }
}

void BBSERVERFacEvalTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleFacEval : Requesting BBNET_FAC_EVAL " 
        << endl;
   }
}

template < class K >
void BBSERVERFacEvalTrace2(
   int Index_i,
   int Field_i,
   int NumPnts_i,
   K*  PntArray_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacEval : ", "Index = ", Index_i);
   OutputSingleItem("bbserver : HandleFacEval : ", "Field = ", Field_i);
   OutputSingleItem("bbserver : HandleFacEval : ", "NumPnts = ",NumPnts_i);
   OutputArray("bbserver : HandleFacEval : ","Input Points",
               "Pnts[",PntArray_i,0,NumPnts_i);
   }
}

void BBSERVERFacEvalTrace3(
   char* Value_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacEval : ", "Value = ", Value_i);
   }
}

void BBSERVERFacsTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleFacs : Requesting BBNET_FACS " 
        << endl;
   }
}

void BBSERVERFacsTrace2( 
   int     BoxIndex_i,
   int     Field_i,
   MP_INT* Card_i,
   double  Prob_i,
   int     Seed_i
   ) 
{
   if ( PRINTLEVEL > 3 ) {
   OutputSingleItem("bbserver : HandleFacs : ", "BoxIndex = ", BoxIndex_i);
   OutputSingleItem("bbserver : HandleFacs : ", "Field = ", Field_i);
   cout << "bbserver : HandleFacs : Card = "; 
   mpz_out_str(stdout, 10, Card_i); cout << endl;
   OutputSingleItem("bbserver : HandleFacs : ", "Prob = ", Prob_i);
   OutputSingleItem("bbserver : HandleFacs : ", "Seed = ", Seed_i);
   }
}

void BBSERVERFacsEvalTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleFacsEval : Requesting BBNET_FACS_EVAL " 
        << endl;
   }
}

template < class K >
void BBSERVERFacsEvalTrace2(
   int Index_i,
   int Field_i,
   int NumPnts_i,
   K*  PntArray_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacsEval : ", "Index = ", Index_i);
   OutputSingleItem("bbserver : HandleFacsEval : ", "Field = ", Field_i);
   OutputSingleItem("bbserver : HandleFacsEval : ", "NumPnts = ",NumPnts_i);
   OutputArray("bbserver : HandleFacsEval : ","Input Points",
               "Pnts[",PntArray_i,0,NumPnts_i);
   }
}

void BBSERVERFacsEvalTrace3(
   char* Value_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacsEval : ", "Value = ", Value_i);
   }
}

void BBSERVERFacsEvalTrace4(
   int Value_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacsEval : ", "NumFacs = ", Value_i);
   }
}

void BBSERVERFacsHMapEvalTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleFacsHMapEval : Requesting BBNET_FACS_HMAP_EVAL " 
        << endl;
   }
}

template < class K >
void BBSERVERFacsHMapEvalTrace2(
   int Index_i,
   int NumPnts_i,
   K*  PntArray_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacsHMapEval : ", "Index = ", Index_i);
   OutputSingleItem("bbserver : HandleFacsHMapEval : ", "NumPnts = ",NumPnts_i);
   OutputArray("bbserver : HandleFacsHMapEval : ","Input Points",
               "Pnts[",PntArray_i,0,NumPnts_i);
   }
}

void BBSERVERFacsHMapEvalTrace3(
   char* Value_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacsHMapEval : ", "Value = ", Value_i);
   }
}

void BBSERVERFacsHMapEvalTrace4(
   int Value_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacsHMapEval : ", "NumFacs = ", Value_i);
   }
}

void BBSERVERSCTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
   cout << "bbserver : HandleSparseConversion : Requesting BBNET_SPARSE" 
        << endl;
   }
}

void BBSERVERSCTrace2( 
   int Field_i,
   int Index_i,
   int NumVars_i,
   BBSPARSEAUX_VarVector& Vars_i,
   BBSPARSEAUX_DegVector& Degs_i,
   int TotalDeg_i,
   MP_INT* Card_i
   ) 
{
   int i;

   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleSparseConversion : ", 
      "Field = ", Field_i);
   OutputSingleItem("bbserver : HandleSparseConversion : ",
      "Index = ", Index_i);
   OutputSingleItem("bbserver : HandleSparseConversion : ",
      "NumVars = ", NumVars_i);
   OutputSingleItem("bbserver : HandleSparseConversion : ",
      "TotalDeg = ", TotalDeg_i);
   cout << "bbserver : HandleSparseConversion : Card = "; 
   mpz_out_str(stdout, 10, Card_i); cout << endl;
   }
   if ( PRINTLEVEL > 3 ) {
   for( i=0; i<NumVars_i; i++ ) {
   cout << "bbserver : HandleSparseConversion : Vars[i] = " << Vars_i[i] 
        << endl;
   cout << "bbserver : HandleSparseConversion : Degs[i] = " << Degs_i[i] 
        << endl;
   }
   }
}

void BBSERVERFacsHMapTrace1(
   int IndexQ_i,
   int IndexZP_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacsHMap : ", "IndexQ = ", 
      IndexQ_i);
   OutputSingleItem("bbserver : HandleFacsHMap : ", "IndexZP = ", 
      IndexZP_i);
   }
}

void BBSERVERSelTrace1(
   int Field_i,
   int BoxIndex_i, 
   int SelIndex_i, 
   int Index_i 
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : ConsSel : ", "Field = ", Field_i);
   OutputSingleItem("bbserver : ConsSel : ", "BoxIndex = ", BoxIndex_i);
   OutputSingleItem("bbserver : ConsSel : ", "SelIndex = ", SelIndex_i);
   OutputSingleItem("bbserver : ConsSel : ", "Index = ", Index_i);
   }
}

template < class K >
void BBSERVERFacHMapEvalTrace1(
   int Index_i,
   int NumPnts_i,
   K*  PntArray_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacHMapEval : ", "Index = ", Index_i);
   OutputSingleItem("bbserver : HandleFacHMapEval : ", "NumPnts = ",NumPnts_i);
   OutputArray("bbserver : HandleFacHMapEval : ","Input Points",
               "Pnts[",PntArray_i,0,NumPnts_i);
   }
}

void BBSERVERFacHMapEvalTrace2(
   char* Value_i
   )
{
   if ( PRINTLEVEL > 2 ) {
   OutputSingleItem("bbserver : HandleFacHMapEval : ", "Value = ", Value_i);
   }
}

#endif

#endif


