
/*-------------------------------------------------------------
  program: bridge.C
  author: Angel L. Diaz

  date: 11/11/96

  description: 

  (c) Copyright 1996 Angel Diaz and Erich Kaltofen, All Rights Reserved
  This code is provided WITHOUT WARRANTY either expressed or implied.
 
-------------------------------------------------------------*/

#include <iostream.h>        // C++ input/output
#include <fstream.h>         // C++ file input/output
#include <unistd.h>
#include <signal.h>
#include "BlackBox/Aux/bbdefs.h"

int IsActive;

void BridgeSignalHandle( int ); 

int main( int argc, char** argv ) 
{
   int ClientPid;

   if ( argc != 3 ) {
      cerr << "bridge : usage: bridge <bridge_pid_file> <client_pid_file>" 
           << endl;
      exit(-1);
   }

   ofstream OutFile( argv[1], ios::out );
   if ( !OutFile ) {
      cerr << "client : cannot open " << argv[1] << " for output" << endl;
   }

   ifstream InFile( argv[2] , ios::in );
   if ( !InFile ) {
      cerr << "client : cannot open " << argv[2] << " for input" << endl;
   }

   OutFile << getpid();
   OutFile.close();

   InFile >> ClientPid;
   kill( ClientPid, SIGUSR2 );

   IsActive = BBDEFS_FALSE;
   signal( SIGUSR2, BridgeSignalHandle );
   while ( !(IsActive) ) { 
      sleep(1); 
   }

   InFile.close();
}

void BridgeSignalHandle ( int ) {
   IsActive = BBDEFS_TRUE;
}

