
/*-------------------------------------------------------------
  module: clienttrace.h
  author: Angel L. Diaz

  date: 11/14/96

  desciption: 
     Tracing routines for: client.C
 
     PRINTLEVEL = 0 ; tracing off
     PRINTLEVEL > 0 ; function tags
     PRINTLEVEL > 1 ; milestone messages
     PRINTLEVEL > 2 ; state variables
     PRINTLEVEL > 3 ; state variables and arrays/vectors

  (c) Copyright 1996 Angel Diaz and Erich Kaltofen, All Rights Reserved
  This code is provided WITHOUT WARRANTY either expressed or implied.

-------------------------------------------------------------*/

#ifndef _BBCLIENTTRACE
#define _BBCLIENTTRACE

#ifdef BBDEFS_SERVER_TRC

#include "BlackBox/Aux/bbtrace.h"

void BBCLIENTVandTrace1( 
   char* Index_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_VAND or BBNET_VANDSHIFT : index = " 
           << Index_i;
   }
}

void BBCLIENTGCDTrace1( 
   char* Index_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_GCD : index = " 
           << Index_i;
   }
}

void BBCLIENTGCDEvalTrace1( 
   char* Value_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_GCD_EVAL : Value = " 
           << Value_i;
   }
}

void BBCLIENTSetPrimeTrace1( 
   char* Prime_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_SETPRIME : prime = " 
           << Prime_i;
   }
}

void BBCLIENTToeTrace1( 
   char* Index_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_TOE : index = " 
           << Index_i;
   }
}

void BBCLIENTFacTrace1( 
   char* Index_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_FAC : index = " 
           << Index_i;
   }
}

void BBCLIENTFacEvalTrace1( 
   char* Value_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_FAC_EVAL : Value = " 
           << Value_i;
   }
}

void BBCLIENTFacsTrace1( 
   char* Index_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_FACS : index = " 
           << Index_i;
   }
}

void BBCLIENTFacsEvalTrace1( 
   char* Value_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_FACS_EVAL : Value = " 
           << Value_i;
   }
}

void BBCLIENTFacsHMapEvalTrace1( 
   char* Value_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_FACS_HMAP_EVAL : Value = " 
           << Value_i;
   }
}

void BBCLIENTFacHMapEvalTrace1( 
   char* Value_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_FAC_HMAP_EVAL : Value = " 
           << Value_i;
   }
}

void BBCLIENTSCTrace1( ) {
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_SPARSE : Done!" << endl; 
   }
}

void BBCLIENTHMapTrace1( 
   char* Index_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_FACS_HMAP : index = " 
           << Index_i;
   }
}

void BBCLIENTSelTrace1( 
   char* Index_i
   ) 
{
   if ( PRINTLEVEL > 2 ) {
      cout << "client : BBNET_SEL : index = " 
           << Index_i;
   }
}

#endif

#endif
