/*===============================================
                 saclib.h

          Header file for SACLIB
===============================================*/
#ifndef SACLIB_H
#define SACLIB_H

#include "sacsys.h"
#include "sactypes.h"


/*-------------------------------------------
  Constants
-------------------------------------------*/

#define NIL            BETA

#define GC_CHECK    0
#define GC_NO_CHECK 1

#define SAC_KEEPMEM 0
#define SAC_FREEMEM 1


/*-------------------------------------------
  Function Prototypes
-------------------------------------------*/

#include "sacproto.h"


/*-------------------------------------------
  Macros
--------------------------------------------*/

#include "sacmacros.h"



/*-------------------------------------------
  External Variables
-------------------------------------------*/

/* List processing */

extern Word AVAIL;
extern char *BACSTACK;
extern Word GCC;
extern Word GCCC;
extern Word GCAC;
extern Word GCGLOBALS;
extern Word GCM;
extern Word NU;
extern Word RHO;
extern Word *SPACE;
extern Word *SPACEB;
extern Word *SPACEB1;
extern Word GCAAVAIL;
extern GCArray *GCASPACE;
extern GCArray *GCASPACEBp;
extern Word NUp;
extern Word BETAp;
extern Word BETApp;

/* Timing */

extern Word TAU;
extern Word TAU0;
extern Word TAU1;

/* Integer arithmetic */

extern Word DELTA;
extern Word EPSIL;
extern Word ETA;
extern Word RINC;
extern Word RMULT;
extern Word RTERM;
extern Word TABP2[];
extern Word THETA;
extern Word ZETA;

/* Miscellaneous */

extern Word NPFDS;
extern Word NPRIME;
extern Word PRIME;
extern Word NSMPRM;
extern Word SMPRM;
extern Word UZ210;
extern Word NPTR1;
extern Word GCAPTR1;

/* Input/Output */

extern Word LASTCHAR;

#endif
