#ifndef LLL__H
#define LLL__H

#include "mat_ZZ.h"


long LLL(matrix(ZZ)& B, long verbose = 0);
long LLL(matrix(ZZ)& B, matrix(ZZ)& U, long verbose = 0);

// performs LLL reduction.
// B is an m x n matrix, viewed as m rows of n-vectors.
// m may be less than, equal to, or greater than n, and 
// the rows need not be linearly independent.
// B is transformed into an LLL-reduced basis, and the return value
// is the rank of B.  Zero rows are placed at the end.
// In the second version, U is set to the transformation matrix,
// so that U is an m x m matrix with U * old-B = new-B.

// The algorithm employed is essentially that of de Weger
// [Algorithms for Diophantine Equations, Disseration,
// CWI, Amsterdam, 1988], modified to allow linear dependent
// inputs.

#endif
