#ifndef matrix__H
#define matrix__H

#include "vector.h"

// matrix templates

#define matrix(T) NAME2(MATRIX___,T)

#define matrix_decl(T)  \
class matrix(T) : public vector(vector(T)) {  public: \
vector(T)& operator()(long i) { return (*this)[i-1]; } \
const vector(T)& operator()(long i) const { return (*this)[i-1]; } \
T& operator()(long i, long j) { return (*this)[i-1][j-1]; } \
const T& operator()(long i, long j) const { return (*this)[i-1][j-1]; } \
long NumRows() const { return length(); } \
long NumCols() const; \
void SetDims(long n, long m); \
}; \
long IsRectangular(const matrix(T)& M); \



#define matrix_impl(T)  \
long matrix(T)::NumCols() const  \
{  if (length() == 0) return 0; else return (*this)[0].length(); }   \
void matrix(T)::SetDims(long n, long m)   \
{   \
   long i;   \
   SetLength(n);   \
   for (i = 0; i < n; i++) (*this)[i].SetLength(m);   \
} \
  \
long IsRectangular(const matrix(T)& M)  \
{  \
   long n = M.NumRows();  \
   if (n == 0) return 1;  \
   long m = M[0].length();  \
   long i;  \
   for (i = 1; i < n; i++)  \
      if (M[i].length() != m)  \
         return 0;  \
   return 1;  \
} \



#endif
