SpecialBarInterp := proc(bb,degf)
local i,      # iterate through X's
      j,      # iterate through Y's
      pruned,
      indep,
      dep,
      deg, 
      tmp,
      ypoly,
      bbcnt;

    pruned := 0; bbcnt := 0; 
    deg := degf + 1;
    ypoly := [];

    # iterate through X's
    for i from 1 to degf+1 do
      # interpolate a polynomial in Y
      dep := []; indep := [];
      for j from 1 to deg do
        bbcnt := bbcnt + 1;
        dep   := [ op(dep), bb([i,j]) - subs(X=i,Y=j,pruned) ]; 
        indep := [ op(indep), j ];
      od;
      ypoly := [ op(ypoly), interp(indep,dep,Y) ];
      deg := deg - 1;

      # interpolate coefficient in X
      dep := []; indep := [];
      for j from 1 to degf-deg+1 do
        indep := [ op(indep), j ]; 
        dep   := [ op(dep), coeff(ypoly[j],Y,deg) ];
      od;
      pruned := pruned + interp(indep,dep,X)*Y^(deg);

      if (printlevel>2) then
        printf(`ypoly[%d]  : %a\n`,i,ypoly[i]);
        printf(`pruned     : %a\n`,pruned);
      fi; 
    od;

   printf(`Algorithm       : dense conversion with pruning\n`);
   printf(`Black Box calls : %d\n`,bbcnt);
   printf(`Algorithm       : dense conversion\n`);
   printf(`Black Box calls : %d\n`,(degf+1)^2);

 RETURN(pruned);
end:

