read `arith.mpl`;
read `gprod.mpl`;
read `parfrac.mpl`;

lift := proc(fbar, g0, g0prod, e, parfrac_coeffs, prod_g0_sup_e_minus_1)
   # fbar is a poly in X and Y, lc[Y](fbar) in K
   # g0 is a list of true factor images of fbar(X,0)
   # g0prod list of products of gi0 g1k , g1k*g2k , ... , g1k*...grk 
   # with multiplicities
   # e is a list of corresponding multiplicities
   # parfrac_coeffs prestores the diophantine solutions
   # prod_g0_sup_e_minus_1 = prod(g0[i], i=1..r)

   local i, ii, j, k, m,   # loop variables
         r,                # number of factors
         ffhat,
         gp,
         gikm1,
         gik,
         g, 
         ttk,
         uk,
         tmp,
         d, dmax,dsum,esum,
         ans;

   r := nops(g0);
   d := array(1..r); dmax := 0; dsum := 0; esum := 0;
   for i from 1 to r do
       esum := esum + e[i]; 
       d[i] := degree(g0[i], X); dsum := dsum + d[i];
       if dmax < d[i] then dmax := d[i]; fi;
   od;

   dmax := degree(fbar,Y);

   gp := array(1..esum); 
   for i from 1 to esum do 
    gp[i] := [];
    gp[i] := [ op(gp[i]), g0prod[i] ]; 
   od;
 
   # Y-adic coefficients of right side
   ffhat := [];
   for i from 0 to dmax do
     ffhat := [ op(ffhat), coeff(fbar, Y, i) ];
   od;

   g     := array(1..r);
   gik   := array(1..r);
   gikm1 := array(1..r);
 
   for i from 1 to r do 
    g[i] := []; g[i] := [ op(g[i]),  g0[i]]; 
   od;
   
   # lift g0[i] from Y^(k-1) to Y^k
   for k from 1 to dmax do 

    if k = 1 then 
     tmp := lstcoeff(gp[esum],k); 
    else
     gp  := gprod(gp, gikm1, gik , e ,r , esum,k-1);
     tmp := lstcoeff(gp[esum],k);
    fi;

    ttk := lstcoeff(ffhat,k) - tmp;

    if not(divide(ttk, prod_g0_sup_e_minus_1, 'uk'))
       then ERROR(`untrue univariate factorization`);
    fi;

    for i from 1 to r do
     m := 'm';
     gik[i]   := sum(coeff(uk, X, m) * parfrac_coeffs[m,i], m=0..dsum-1);
     gikm1[i] := g[i];
     g[i]     := shadd(gikm1[i],gik[i],k);

    od;
   od;
 
   ans := []; for i from 1 to r do ans := [ op(ans) , chngrep(g[i]) ]; od;

 RETURN(ans);
end:
