find_parfrac_coeffs := proc(ufactors, uexpos)
   local r, i, m, d,
         h0s, gi0, hi0,
         si0,ti0,
         hat_gi0m, hat_hi0m,
         fprod,numeri,
         parfrac;

   r := nops(ufactors);

   # array of univariate co-factors
   h0s := array[2..r];
   fprod := ufactors[r];
   h0s[r] := ufactors[r];
   for i from r-1 to 2 by -1 do
       fprod := expand(fprod * ufactors[i]);
       h0s[i] := fprod;
   od;

   d := degree(ufactors[1], X) + degree(h0s[2], X);

   parfrac = array(0..d-1, 1..r);

   si0 := array[1..r-1]; ti0 := array[1..r-1];
   for i from 1 to r-1 do
     gi0 := ufactors[i];
     hi0 := h0s[i+1];
     gcdex(gi0, hi0, 1, X, 'si0[i]','ti0[i]');
   od;

   for m from 0 to d-1 do
       numeri := X^m;
        for i from 1 to r-1 do
            gi0 := ufactors[i];
            hi0 := h0s[i+1];
            hat_gi0m := rem(ti0[i]*numeri,gi0,X);
            hat_hi0m := rem(si0[i]*numeri,hi0,X);
            parfrac[m, i] := hat_gi0m/uexpos[i];
            if i = r-1 then
               parfrac[m, r] := hat_hi0m/uexpos[r];
            else
               numeri := hat_hi0m;
            fi;
        od;
   od;
   RETURN(eval(parfrac));
end:

