read `arith.mpl`;

ggprod := proc(prevgprods,gik,gikp1,ei,r,esum,K)
# Compute the      (g1k + gh1k)^e1*(g2k + gh2k)^e2*...*(gik + ghik)^er
# prevgprods holds g1k , g1k*g2k , ... , g1k*...grk with multiplicities
# gik holds        g1k , g2k , ... , grk
# gikp1 holds      gh1kp1 , gh2kp1 , ... , ghrkp1
# ei holds the exponents e1, e2, ... , ei
# r number of factors
# esum e1 + e2 + ... + er
# the length of prevgprods and newgprods is esum
 local ell,i,   # loop counters
       t1,t2,t3,t4,
       pell,
       a,ah,
       newgprods;

 for i from 1 to esum do
 printf(`ggprod              : prevgprods[%d]=%a\n`,i,prevgprods[i]);
 od;
 for i from 1 to r do
 printf(`ggprod              : gik[%d] = %a\n`,i,gik[i]);
 printf(`ggprod              : gikp1[%d] = %a\n`,i,gikp1[i]);
 printf(`ggprod              : ei[%d] = %a\n`,i,ei[i]);
 od;
 printf(`ggprod              : r = %d\n`,r);
 printf(`ggprod              : esum = %d\n`,esum);
 printf(`ggprod              : k  = %d\n`,K);

 a  := array[1..esum];
 ah := array[1..esum];
 newgprods := array[1..esum];

 for i from 1 to esum do a[i] := []; ah[i] := []; newgprods[i] := []; od;

 a[1]  := prevgprods[1];
 ah[1] := [ 0 ];
 ah[1] := shadd(ah[1],gikp1[1],K);
 newgprods[1] := add(a[1],ah[1]);

 printf(`ggprod              : a[%d]=%a\n`,1,a[1]);
 printf(`ggprod              : ah[%d]=%a\n`,1,ah[1]);
 printf(`ggprod              : newgprods[%d]=%a\n`,1,newgprods[1]);

 pell := 2;
 t1 := []; t2 := []; t3 := []; t4 := [];
 for i from 2 to ei[1] do
  a[i] := prevgprods[i];
  t1 := mult(ah[i-1],gik[1]);
  t2 := shmult(a[i-1],gikp1[1],K);
  t3 := shmult(ah[i-1],gikp1[1],K);
  t4 := add(t1,t2);

  printf(`ggprod              : t1=%a\n`,t1);
  printf(`ggprod              : t2=%a\n`,t2);
  printf(`ggprod              : t3=%a\n`,t3);
  printf(`ggprod              : t4=%a\n`,t4);

  ah[i] := add(t4,t3); 
  newgprods[i] := add(a[i],ah[i]);  

  printf(`ggprod              : a[%d]=%a\n`,i,a[i]);
  printf(`ggprod              : ah[%d]=%a\n`,i,ah[i]);
  printf(`ggprod              : newgprods[%d]=%a\n`,i,newgprods[i]);

  pell := pell + 1;
 od;

 for ell from 2 to r do

  printf(`ggprod              : **** ell  is %d \n`,ell);
  printf(`ggprod              :      pell is %d \n`,pell);
  t1 := []; t2 := []; t3 := []; t4 := [];

  for i from 1 to ei[ell] do
   a[pell]  := prevgprods[pell];
   t1 := mult(ah[pell-1],gik[ell]);
   t2 := shmult(a[pell-1],gikp1[ell],K);
   t3 := shmult(ah[pell-1],gikp1[ell],K);
   t4 := add(t1,t2);

   printf(`ggprod              : a[%d]=%a\n`,pell,a[pell]);
   printf(`ggprod              : t1=%a\n`,t1);
   printf(`ggprod              : t2=%a\n`,t2);
   printf(`ggprod              : t3=%a\n`,t3);
   printf(`ggprod              : t4=%a\n`,t4);

   ah[pell] := add(t4,t3);
   newgprods[pell] := add(a[pell],ah[pell]);

   printf(`ggprod              : ah[%d]=%a\n`,i,ah[pell]);
   printf(`ggprod              : newgprods[%d]=%a\n`,i,newgprods[pell]);


   pell := pell + 1;
   od;
 od;

 RETURN(eval(newgprods));

end:

gprod := proc(prevgprods,gik,gikp1,ei,r,esum)
# Compute the      (g1k + gh1k)^e1*(g2k + gh2k)^e2*...*(gik + ghik)^er
# prevgprods holds g1k , g1k*g2k , ... , g1k*...grk with multiplicities
# gik holds        g1k , g2k , ... , grk
# gikp1 holds      gh1kp1 , gh2kp1 , ... , ghrkp1
# ei holds the exponents e1, e2, ... , ei
# r number of factors
# esum e1 + e2 + ... + er
# the length of prevgprods and newgprods is esum
 local ell,i,   # loop counters
       pell,
       a,ah,
       newgprods;

 a  := array[1..esum];
 ah := array[1..esum];
 newgprods := array[1..esum];

 a[1]  := prevgprods[1];
 ah[1] := gikp1[1];
 newgprods[1] := a[1] + ah[1];

 pell := 2;
 for i from 2 to ei[1] do
  a[i] := prevgprods[i];
  ah[i] := ah[i-1]*gik[1] + a[i-1]*gikp1[1] +
           ah[i-1]*gikp1[1];
  newgprods[i] := a[i] + ah[i];
  pell := pell + 1;
 od;

 for ell from 2 to r do
  for i from 1 to ei[ell] do
   a[pell]  := prevgprods[pell];
   ah[pell] := ah[pell-1]*gik[ell] + a[pell-1]*gikp1[ell] + 
               ah[pell-1]*gikp1[ell];
   newgprods[pell] := a[pell] + ah[pell];
   pell := pell + 1;
   od;
 od;

 RETURN(eval(newgprods));

end:	

find_parfrac_coeffs := proc(ufactors, uexpos)
   local r, i, m, d,
         h0s, gi0, hi0,
         si0,ti0,
         hat_gi0m, hat_hi0m,
         fprod,numeri,
         parfrac;

   if ( printlevel > 2 ) then
    printf(`find_parfrac_coeffs : Starting\n`);
   fi;

   r := nops(ufactors);
 
   if ( printlevel > 2 ) then
    printf(`find_parfrac_coeffs : r %d\n`,r);
    for i from 1 to r do
     printf(`find_parfrac_coeffs : ufactors[%d] = %a`,i,ufactors[i]); 
     printf(`\n`);
    od;
   fi;

   # array of univariate co-factors
   h0s := array[2..r];
   fprod := ufactors[r];
   h0s[r] := ufactors[r];
   for i from r-1 to 2 by -1 do
       fprod := expand(fprod * ufactors[i]);
       h0s[i] := fprod;
   od;

   if ( printlevel > 2 ) then
    for i from 2 to r do
     printf(`find_parfrac_coeffs : h0s[%d] = %a\n`,i,h0s[i]); 
    od;
   fi;    
   
   
   d := degree(ufactors[1], X) + degree(h0s[2], X);

   if ( printlevel > 2 ) then
    printf(`find_parfrac_coeffs : d = %d\n`,d);
   fi;

   parfrac = array(0..d-1, 1..r);

   if ( printlevel > 2 ) then
    printf(`find_parfrac_coeffs : calculating parfrac\n`);
   fi;
 
   si0 := array[1..r-1]; ti0 := array[1..r-1];
   for i from 1 to r-1 do
     gi0 := ufactors[i]; 
     hi0 := h0s[i+1];
     gcdex(gi0, hi0, 1, X, 'si0[i]','ti0[i]');
   od;

   for m from 0 to d-1 do
       numeri := X^m;
        for i from 1 to r-1 do
            gi0 := ufactors[i];
            hi0 := h0s[i+1];
            hat_gi0m := rem(ti0[i]*numeri,gi0,X);
            hat_hi0m := rem(si0[i]*numeri,hi0,X);
            if printlevel > 2 then
               printf(`\n*** m = %d ; i = %d ***\n`,m,i);
               printf(`find_parfrac_coeffs : gi0 %a\n`,gi0);
               printf(`find_parfrac_coeffs : hi0 %a\n`,hi0);
               printf(`find_parfrac_coeffs : hat_gi0m %a\n`,hat_gi0m);
               printf(`find_parfrac_coeffs : hat_hi0m %a\n`,hat_hi0m);
            fi;
            parfrac[m, i] := hat_gi0m/uexpos[i];
            if i = r-1 then
               parfrac[m, r] := hat_hi0m/uexpos[r];
            else 
               numeri := hat_hi0m;
            fi;
        od;
   od;

   if ( printlevel > 2 ) then
    for m from 0 to d-1 do
     for i from 1 to r do
      printf(`parfrac[%d,%d]=%a ; `,m,i,parfrac[m,i]);  
     od;
    printf(`\n`);
    od;
   fi;

   RETURN(eval(parfrac));
end:



lift := proc(fbar, g0, g0prod, e, parfrac_coeffs, prod_g0_sup_e_minus_1)
   # fbar is a poly in X and Y, lc[Y](fbar) in K
   # g0 is a list of true factor images of fbar(X,0)
   # g0prod list of products of gi0 g1k , g1k*g2k , ... , g1k*...grk with multiplicities
   # e is a list of corresponding multiplicities
   # parfrac_coeffs prestores the diophantine solutions
   # prod_g0_sup_e_minus_1 = prod(g0[i], i=1..r)

   local i, ii, j, k, m,   # loop variables
         r,                # number of factors
         fhat,ffhat,
         gp,ggp,
         gikm1,ggikm1,
         gik,ggik,
         g,gg, 
         tk,ttk,
         uk,uuk,
         tmp,ttmp,
         d, dmax,dsum,esum;

   if ( printlevel > 2 ) then
    printf(`lift                : Starting\n`);
   fi;
 
   r := nops(g0);
   d := array(1..r); dmax := 0; dsum := 0; esum := 0;
   for i from 1 to r do
       esum := esum + e[i]; 
       d[i] := degree(g0[i], X); dsum := dsum + d[i];
       if dmax < d[i] then dmax := d[i]; fi;
   od;

   dmax := degree(fbar,Y);

   gp := array(1..esum);
   for i from 1 to esum do gp[i] := g0prod[i]; od;
   ggp := array(1..esum); 
   for i from 1 to esum do 
    ggp[i] := [];
    ggp[i] := [ op(ggp[i]), g0prod[i] ]; 
    if ( printlevel > 2 ) then
     printf(`lift                : ggp[%d] = %a \n`,i,ggp[i]);
    fi;
   od;
 
   if ( printlevel > 2 ) then
    printf(`lift                : r %d\n`,r);
    printf(`lift                : dmax %d\n`,dmax);
    printf(`lift                : dsum %d\n`,dsum);
    printf(`lift                : esum %d\n`,esum);
    for i from 1 to r do
     printf(`lift                : d[%d] =%a \n`,i,d[i]); 
    od;
   fi;

   # Y-adic coefficients of right side
   if ( printlevel > 2 ) then 
    printf(`lift                : Y-adic coefficients\n`); 
   fi;
   fhat := array(0..dmax);
   for i from 0 to dmax do
     fhat[i] := coeff(fbar, Y, i);
     if ( printlevel > 2 ) then 
      printf(`lift                : fhat[%d] =%a \n`,i,fhat[i]); fi;
   od;

   # Y-adic coefficients of right side
   if ( printlevel > 2 ) then
    printf(`lift                : Y-adic coefficients\n`);
   fi;
   ffhat := [];
   for i from 0 to dmax do
     ffhat := [ op(ffhat), coeff(fbar, Y, i) ];
   od;
   if ( printlevel > 2 ) then 
    printf(`lift                : ffhat =%a \n`,ffhat); fi;

   g     := array(1..r);
   gik   := array(1..r);
   gikm1 := array(1..r);

   gg     := array(1..r);
   ggik   := array(1..r);
   ggikm1 := array(1..r);
 
   for i from 1 to r do g[i] := g0[i]; od;
   for i from 1 to r do 
    gg[i] := []; gg[i] := [ op(gg[i]),  g0[i]]; 
    if ( printlevel > 2 ) then 
      printf(`lift                : gg[%d] =%a \n`,i,gg[i]); fi;
   od;
   
   # lift g0[i] from Y^(k-1) to Y^k
   for k from 1 to dmax do 
       if ( printlevel > 2 ) then
         printf(`lift                : *** k = %d ***\n`,k);
       fi;

       if k = 1 then 
       tmp  := coeff(expand(gp[esum]),Y,k);
       ttmp := lstcoeff(ggp[esum],k); 
       else
       gp := gprod(gp, gikm1, gik , e ,r , esum); 
       tmp  := coeff(expand(gp[esum]),Y,k);
       ggp := ggprod(ggp, ggikm1, ggik , e ,r , esum,k-1);
       ttmp := lstcoeff(ggp[esum],k);
       fi;

       tk := fhat[k] - tmp;
       ttk := lstcoeff(ffhat,k) - ttmp;

       if ( printlevel > 2 ) then
         printf(`lift                : tmp = %a\n`,tmp);
         printf(`lift                : ttmp = %a\n`,ttmp);
         printf(`lift                : fhat[%d] = %a\n`,k,fhat[k]);
         printf(`lift                : ffhat[%d] = %a\n`,k,lstcoeff(ffhat,k));
         printf(`lift                : tk = %a\n`,tk);
         printf(`lift                : ttk = %a\n`,ttk); 
       fi;

       if not(divide(tk, prod_g0_sup_e_minus_1, 'uk'))
          then ERROR(`untrue univariate factorization`);
       fi;

       for i from 1 to r do
           if ( printlevel > 2 ) then
             printf(`lift                :          *** i = %d ***\n`,i);
           fi;
           m := 'm';
           gik[i]    := Y^k * sum(coeff(uk, X, m) * 
                        parfrac_coeffs[m,i], m=0..dsum-1); 
           ggik[i]   := sum(coeff(uk, X, m) *
                        parfrac_coeffs[m,i], m=0..dsum-1);
           gikm1[i]  := g[i];
           ggikm1[i] := gg[i];
           g[i]      := gikm1[i] + gik[i];
           gg[i]     := shadd(ggikm1[i],ggik[i],k);

           if ( printlevel > 2 ) then
            printf(`lift                : gik[%d] = %a\n`,i,gik[i]);
            printf(`lift                : ggik[%d] = %a\n`,i,ggik[i]);
            printf(`lift                : gikm1[%d] = %a\n`,i,gikm1[i]);
            printf(`lift                : ggikm1[%d] = %a\n`,i,ggikm1[i]);
            printf(`lift                : g[%d] = %a\n`,i,g[i]);
            printf(`lift                : gg[%d] = %a\n`,i,gg[i]);
           fi;
       od;

   od;

 for i from 1 to r do
  printf(`lift                : factor[%d]=%a\n`,i,chngrep(gg[i]));
 od;

RETURN([seq(g[ii], ii=1..r)]);
end:
