> interface(verboseproc=2);
> readlib(`factor/replcoeff`);

proc(a,x,c)
options `Copyright 1993 by Waterloo Maple Software`;
    degree(a,x); expand(c*x^")-expand(lcoeff(a,x)*x^")+a
end

> readlib(`factor/diophant`); 

proc(a,c,Id,d,p,k)
local
  modulus,r,n,A,i,j,q,b,eqn,Inew,anew,cnew,sigma,e,monom,m,cm,deltas,x1,terms,z
  ;
options `Copyright 1993 by Waterloo Maple Software`;
    if nargs < 5 or 6 < nargs or not type(a,list) or not type(Id,list) or
        not type(d,integer) or d < 0 or not type(p,integer) or p < 2 or
        nargs = 6 and (not type(k,integer) or k < 1) then
        ERROR(`wrong number (or type) of arguments`)
    fi;
    if nargs < 6 then modulus := p else modulus := p^k fi;
    r := nops(a);
    n := nops(Id);
    if 0 < n then
        A := expand(product('a[i]',i = 1 .. r));
        for j to r do  divide(A,a[j],'q'); b[j] := q od;
        eqn := op(n,Id);
        Inew := [op(1 .. n-1,Id)];
        anew := subs(eqn,a);
        cnew := subs(eqn,c);
        sigma := `factor/diophant`(anew,cnew,Inew,args[4 .. nargs]);
        e := mods(c-expand(sum('sigma[i]*b[i]',i = 1 .. r)),modulus);
        monom := 1;
        for m to d while e <> 0 do
            monom := expand(monom*(op(1,eqn)-op(2,eqn)));
            cm := coeftayl(e,eqn,m);
            if cm <> 0 then
                `factor/diophant`(anew,cm,Inew,args[4 .. nargs]);
                deltas := map(proc(t,s) expand(t*s) end,",monom);
                sigma := zip(<x+y|x,y>,sigma,deltas);
                e := e-expand(sum('deltas[i]*b[i]',i = 1 .. r));
                e := mods(e,modulus)
            fi
        od
    else
        indets(a) union indets(c);
        if nops(") = 1 then x1 := op(")
        else ERROR(`invalid indeterminates`)
        fi;
        if type(c,`+`) then terms := [op(c)] else terms := [c] fi;
        sigma := [0 $ r];
        for z in terms do
            m := degree(z,x1);
            cm := lcoeff(z);
            `factor/diophant1`(a,x1,m,args[5 .. nargs]);
            deltas := map(proc(t,s) t*s end,",cm);
            sigma := zip(<x+y|x,y>,sigma,deltas)
        od
    fi;
    mods(sigma,modulus)
end
> readlib('coeftayl');

proc(e,eqn,k)
local i,x,alpha,c,r;
options `Copyright 1993 by Waterloo Maple Software`;
    if nargs <> 3 or not type(eqn,`=`) then
        ERROR(`wrong number (or type) of parameters`)
    elif type(op(1,eqn),name) and type(k,integer) and 0 <= k then
        if k = 0 then c := e else c := diff(e,op(1,eqn) $ k) fi;
        r := traperror(subs(eqn,c)/k!);
        if r <> lasterror then r else limit(c,eqn)/k! fi
    elif type(op(1,eqn),list) and type(op(2,eqn),list) and type(k,list) and
        nops(op(1,eqn)) = nops(k) and nops(op(2,eqn)) = nops(k) and 0 < nops(k)
         and not has(map(proc(n) type(n,integer) and 0 <= n end,k),false) then
        c := e;
        x := op(1,eqn);
        alpha := op(2,eqn);
        if convert(k,`+`) <> 0 then
            for i to nops(k) do  to k[i] do  c := diff(c,x[i]) od od
        fi;
        r := traperror(subs({'x[i] = alpha[i]' $ ('i' = 1 .. nops(k))},c));
        if r = lasterror then
            r := limit(c,{'x[i] = alpha[i]' $ ('i' = 1 .. nops(k))})
        fi;
        if r = 0 then r else r/product('k[i]!','i' = 1 .. nops(k)) fi
    else ERROR(`wrong type of parameters`)
    fi
end
> readlib('coeftayl');

proc(e,eqn,k)
local i,x,alpha,c,r;
options `Copyright 1993 by Waterloo Maple Software`;
    if nargs <> 3 or not type(eqn,`=`) then
        ERROR(`wrong number (or type) of parameters`)
    elif type(op(1,eqn),name) and type(k,integer) and 0 <= k then
        if k = 0 then c := e else c := diff(e,op(1,eqn) $ k) fi;
        r := traperror(subs(eqn,c)/k!);
        if r <> lasterror then r else limit(c,eqn)/k! fi
    elif type(op(1,eqn),list) and type(op(2,eqn),list) and type(k,list) and
        nops(op(1,eqn)) = nops(k) and nops(op(2,eqn)) = nops(k) and 0 < nops(k)
         and not has(map(proc(n) type(n,integer) and 0 <= n end,k),false) then
        c := e;
        x := op(1,eqn);
        alpha := op(2,eqn);
        if convert(k,`+`) <> 0 then
            for i to nops(k) do  to k[i] do  c := diff(c,x[i]) od od
        fi;
        r := traperror(subs({'x[i] = alpha[i]' $ ('i' = 1 .. nops(k))},c));
        if r = lasterror then
            r := limit(c,{'x[i] = alpha[i]' $ ('i' = 1 .. nops(k))})
        fi;
        if r = 0 then r else r/product('k[i]!','i' = 1 .. nops(k)) fi
    else ERROR(`wrong type of parameters`)
    fi
    indets(Id);
    indets(u) union indets(a);
    " minus "";
    if nops(") = 1 then x[1] := op(")
    else ERROR(`inconsistent indeterminates`)
    fi;
    n := nops(u);
    if degree(a,x[1]) <> sum('degree(u[i],x[1])',i = 1 .. n) then
        ERROR(`inconsistent degrees`)
    fi;
    modulus := p^l;
    v := nops(Id)+1;
    A[v] := a;
    for j from v by -1 to 2 do
        eqn := Id[j-1];
        A[j-1] := mods(subs(eqn,A[j]),modulus);
        x[j] := op(1,eqn);
        alpha[j] := op(2,eqn)
    od;
    map(proc(x,e) degree(e,x) end,{x[i] $ (i = 2 .. v)},a);
    maxdeg := max(op("));
    U := u;
    for j from 2 to v do
        U1 := U;
        monomial := 1;
        nfacts := n;
        for m to n do
            if lcU[m] <> 1 then
                mods(subs(Id[j .. v-1],lcU[m]),modulus);
                U := subsop(m = `factor/replcoeff`(U[m],x[1],"),U)
            fi
        od;
        e := A[j]-expand(product('U[i]',i = 1 .. n));
        for k to degree(A[j],x[j]) while e <> 0 do
            monomial := expand(monomial*(x[j]-alpha[j]));
            c := coeftayl(e,x[j] = alpha[j],k);
            if c <> 0 then
                `factor/diophant`(U1,c,[op(1 .. j-2,Id)],maxdeg,p,l);
                deltaU := map(proc(t,m) expand(t*m) end,",monomial);
                U := zip(<x+y|x,y>,U,deltaU);
                U := mods(U,modulus);
                e := A[j]-expand(product('U[i]',i = 1 .. n));
                e := mods(e,modulus);
                if e <> 0 then
                    altered := false;
                    for m to n while 1 < nfacts do
                        if U[m] <> 1 then
                            if divide(A[j],U[m],'q') then
                                A[j] := q;
                                facts[m] := U[m];
                                U := subsop(m = 1,U);
                                U1 := subsop(m = 1,U1);
                                nfacts := nfacts-1;
                                altered := true
                            fi
                        fi
                    od;
                    userinfo(3,{factor,gcd},'lifted',x[j]^k,
                        'altered' = altered,`if`(altered,'U' = U,NULL));
                    if altered then
                        if nfacts = 1 then
                            for m while U[m] = 1 do   od;
                            U := subsop(m = mods(A[j],modulus),U);
                            e := 0
                        else
                            e := A[j]-expand(product('U[i]',i = 1 .. n));
                            e := mods(e,modulus)
                        fi
                    fi
                fi
            fi
        od;
        for m to n do  if U[m] = 1 then U := subsop(m = facts[m],U) fi od
    od;
    if a-expand(product('U[i]',i = 1 .. n)) = 0 then RETURN(U)
    else RETURN(FAIL)
    fi
end

