gprod := proc(prevgprods,gik,gikp1,ei,r,esum,K,dmax)
# Compute the      (g1k + gh1k)^e1*(g2k + gh2k)^e2*...*(gik + ghik)^er
# prevgprods holds g1k , g1k*g2k , ... , g1k*...grk with multiplicities
# gik holds        g1k , g2k , ... , grk
# gikp1 holds      gh1kp1 , gh2kp1 , ... , ghrkp1
# ei holds the exponents e1, e2, ... , ei
# r number of factors
# esum e1 + e2 + ... + er
# K for gikp1
# truncate arithmetic at dmax
# the length of prevgprods and newgprods is esum
 local ell,i,   # loop counters
       t1,t2,t3,t4,
       pell,
       a,ah,
       newgprods;

 a  := array[1..esum];
 ah := array[1..esum];
 newgprods := array[1..esum];

 for i from 1 to esum do a[i] := []; ah[i] := []; newgprods[i] := []; od;

 a[1]  := prevgprods[1];
 ah[1] := [ 0 ];
 ah[1] := shadd(ah[1],gikp1[1],K);
 newgprods[1] := add(a[1],ah[1]);

 pell := 2;
 t1 := []; t2 := []; t3 := []; t4 := [];
 for i from 2 to ei[1] do
  a[i] := prevgprods[i];
  t1 := mult(ah[i-1],gik[1],dmax);
  t2 := shmult(a[i-1],gikp1[1],K,dmax);
  t3 := shmult(ah[i-1],gikp1[1],K,dmax);
  t4 := add(t1,t2);
  ah[i] := add(t4,t3);
  newgprods[i] := add(a[i],ah[i]);
  pell := pell + 1;
 od;

 for ell from 2 to r do
  t1 := []; t2 := []; t3 := []; t4 := [];
  for i from 1 to ei[ell] do
   a[pell]  := prevgprods[pell];
   t1 := mult(ah[pell-1],gik[ell],dmax);
   t2 := shmult(a[pell-1],gikp1[ell],K,dmax);
   t3 := shmult(ah[pell-1],gikp1[ell],K,dmax);
   t4 := add(t1,t2);
   ah[pell] := add(t4,t3);
   newgprods[pell] := add(a[pell],ah[pell]);
   printf(`***\n`);
   printf(`pell %a\n`,pell);
   printf(`a[%d] = %a\n`,pell,a[pell]);
   printf(`ah[%d] = %a\n`,pell,ah[pell]);
   printf(`newgprods[%d] = %a\n`,pell,newgprods[pell]);
      printf(`***\n`);

   pell := pell + 1;
   od;
 od;

 RETURN(eval(newgprods));
end:
