Date 2-15-96 (expanded notes)

Erich,

 DISCUSSION: distinct stream of field elements generator

 The current design is to overload the ++ operator in the field
 element class to return the next "discinct" element starting at the
 value found in the field member variable. On instantiation of a field
 element the user can start the stream at some element and use that
 variable as the stream field.

 DISCUSSION: static information used in the interpolation algorithm

 The options we have discussed are as follows :

  1) rewrite the template interpolation function as an overloaded concrete
     function taking into account each possible combination and making this
     a friend of the univariate polynomial adaptor class. Moving all static
     information into the polynomial adaptor class.

      Pros: + static information can be shared between the "deterministic"
              polynomial interpolation constructor and the "probabilistic"
              concrete interpolation functions.

      Cons: + code bloat
            + the "safe" static information problem remains

  2) move the static information into the black box, on construction the
     static information needed for the interpolation steps is computed and 
     stored once and passed as a parameter to the interpolation functions.

      Pros: + this solves the "safe" static information problem which will
              lead to faster results since the static information never has
              to be recomputed
            + This information can be distributed along with the "black box
              identifier" for efficient remote evaluation. 
            + no need for option 1
            + static information can be shared between the "deterministic"
              polynomial interpolation constructor and the "probabilistic"
              concrete interpolation functions.
 
      Cons: + different instances do not share static information
           
  3) a possible solution to the "safe" static information problem is to pass
     a stream with an "identifier" to the black box constructor. This way
     when it calls the interpolation functions (with the stream as an 
     argument) the interpolation function can determine the validity of
     the current static information.

 DISCUSSION: bivariate arithmetic
 
 I took the view of K[x][y]. Perhaps we can look over the code and discuss
 some of the issues such as the set monomial constructor, and designing
 it in such a way it can plug into the GCD implementation.

 DISCUSSION: next steps

 + work on todays decisions
 + get ready for the black box factorization
    - continue with the bivariate arithmetic
    - hensel lifting
 + sparse interpolation  

Yours,

Angel
