Pade := proc(bb,d,e,p,n,lc)
# bb   black box for f/g
# d,e  degree bounds
# p    linearly transformed points in varibale X
local J,
      i,k,
      b,
      I,
      A,
      h, 
      y,
      pnts,
      value,
      ans;

   # find a set of d+e+1 integers not roots of 
   # gh(X) = g(X,u2*X+v2,...,un*X+vn) as well as 
   # values of f/g((X,u2*X+v2,...,un*X+vn) at those points
   b    := d+2*e+1;
   k    := 0;
   ans  := array(1..2);
   A    := []; I := []; 
 
   for J from 1 to b do
     # must check for invalid points
     pnts := [];
     for i from 1 to n do pnts := [ op(pnts), subs(X=J,p[i]) ]; od;
     value := bb(pnts);
     k := k + 1;
     A := [ op(A), value ];
     I := [ op(I), J ];
     if k = d+e+1 then break; fi;
   od;
   if k < d+e+1 then ans[1] := 0; ans[2] := 0; RETURN(ans); fi;

   h := interp(I,A,X);
   y := (X - I[1]);
   for i from 2 to k do 
     y := y*(X - I[i]);
   od;

   ans := SpecialExtGcd(h,y,d,lc);

   # for debugging purposes
   if ( ans[1] <> rem(ans[2]*h,y,X) )
    then ERROR(`incorrect fh and gh`);
   fi;

 RETURN(ans);
end:
 
SpecialExtGcd := proc(H,Y,d,lc)
# given polynomials h(X) and y(X) and degree bounds d and e,
# compute polynomials fh(X) and gh(X) such that
# fh(X) == gh(X)*h(X) (mod y(X)) and GCD(fh(X),gh(X)) =1, 
# deg(fh(X)) <= d, deg(gh(X)) <= e, and ldcf(gh(X)) = 1
# lc
local  h,g,q,
       t,
       ell,
       ans;

  h   := [ expand(Y), H];  
  g   := [ 0, 1];
  q   := [ 0, 0];
  ell := 1; 
  ans := array(1..2);

  while ( degree(h[ell]) > d ) do
    ell := ell + 1;
    h  := [ op(h), rem(h[ell-1],h[ell],X) ];
    if not(divide((h[ell-1] - h[ell+1]),h[ell],'t'))
      then ERROR(`division not exact`);
    fi;
    q  := [ op(q), t ];
    g  := [ op(g), g[ell-1] - q[ell+1]*g[ell] ];

  od;

  ans[1] := lc*(expand(h[ell])/lcoeff(expand(g[ell]))); 
  ans[2] := lc*(expand(g[ell])/lcoeff(expand(g[ell])));

 RETURN(ans);

end:
