raise := proc(p,e,d,i,m)
local j,prod;

   if i = 1 then
    prod := modp( p[1]^d, m); 
   else
    prod := modp( p[1]^e[1], m); 
    for j from 2 to i-1 do
     prod := modp( prod*(p[j]^e[j]), m);
    od;
    prod := modp( prod*p[i]^d, m);
   fi;

 RETURN(prod);
end:

nextJi := proc(x,nJi,k)
local i,Ji;

   Ji := [];
   for i from 1 to k do
     if x[i] <> 0 then
       Ji := [ op(Ji), nJi[i] ];
     fi;  
   od;

 RETURN(Ji);
end:

buildpoly := proc(x,nJi,k,vars,n,modulus)
local i,j,poly,m;

   poly := 0;
   for i from 1 to k do
    if x[i] <> 0 then
      m := 1;
      for j from 1 to n do
       m := m*vars[j]^nJi[i][j];
      od; 
      poly := modp( poly + x[i]*m, modulus);
    fi;
   od;

 RETURN(poly);
end:

getdeg := proc(exp,i)
local j,d;

   d := exp[1];
   for j from 2 to i do
     d := d - exp[j];
   od;

 RETURN(d);
end:

prune :=proc(l,Ji,vars,x)
local i,n,xx,nn,
      p,nl,nJi,ans;

    nn := nops(x);
    n := nops(l);
    p := 0;
    ans := [];
    nl := []; nJi := [];


    xx := [];
    for i from 1 to nn do
      if x[i] <> 0 then
       xx := [ op(xx), x[i] ];
      fi;
    od;

    for i from 1 to n do 
      if l[i] = 0 then
        p := p + xx[i]*getmon(Ji[i],vars);
      else
        nl  := [ op(nl), l[i] ]; 
        nJi := [ op(nJi), Ji[i] ]; 
      fi;
    od;
    ans := [ nl, nJi, p ];

 RETURN(ans);
end:

getmon := proc(exps,vars)
local i,n,monomial;

   n := nops(exps);
#   if n = 1 then
#     monomial := 0;
#   else
     monomial := 1; 
     for i from 2 to n do
       monomial := monomial*vars[i]^exps[i]; 
     od; 
#   fi;

 RETURN(monomial);   
end:
