F := x^8 + x^6 - 3*x^4 - 3*x^3 + 8*x^2 + 2*x - 5;
G := 3*x^6 + 5*x^4 - 4*x^2 - 9*x + 21;

F2 := x+1;
G2 := 0;
tmp := F2; F2 := (x^2-2)*F2 + G2; G2 := tmp;
tmp := F2; F2 := (-x+5)*F2 + G2; G2 := tmp;
tmp := F2; F2 := (3*x^3+3)*F2 + G2; G2 := tmp;
tmp := F2; F2 := (10*x^2-3)*F2 + G2; G2 := tmp;
tmp := F2; F2 := (-27*x^4+9)*F2 + G2; G2 := tmp;
tmp := F2; F2 := (2*x^5+13)*F2 + G2; G2 := tmp;
F2 := expand(F2); G2 := expand(G2);

subres := proc(F, G, x, j)
# compute the j-th subresultant of F and G w.r.t the variable x
# algorithm is Brown's subresultant PRS in Knuth, vol. 2
   local U, V, g, h, delta, R, ell;
   U := F; V := G; g := 1; h := 1;
   delta := degree(U, x) - degree(V, x);
   while( degree(V, x) > j )
   do 
      ell := lcoeff(V, x);
      R := rem(ell^(delta+1)*U, V, x);
      if (R = 0) then RETURN(0); fi;

      U := V; V := (-1)^(delta+1) * R / (g*h^delta);
      
      g := lcoeff(U, x); h := h^(1-delta) * g^delta;
      delta := degree(U, x) - degree(V, x);

   od;

   g := lcoeff(V, x); h := h^(1-delta) * g^delta;

   if( degree(V, x) = j) then RETURN(h/g*V); fi;
   if( degree(U, x)-1 = j) then RETURN(1 * V); fi;
   RETURN(0);
end;

with(linalg):
toedet := proc(row1, col1)
   local i, n, x, Tau, S;
   n := vectdim(row1);
   Tau := 0; x := 'x';
   # compute Tau
   for i from n by -1 to 1 do
       Tau := Tau + col1[i] * x^(n-i);
   od;
   for i from 2 to n do 
       Tau := Tau + row1[i] * x^(i+n-2);
   od;
   print( x^(2*n-1) );
   print( Tau );
   S := subres(x^(2*n-1), Tau, x, n-1);
   if( degree(S, x) < n-1 ) then RETURN(0); fi;
   RETURN( lcoeff(S, x) );
end;

subresp := proc(F, G, x, j, p)
# compute the j-th subresultant of F and G w.r.t the variable x
# algorithm is Brown's subresultant PRS in Knuth, vol. 2
   local U, V, g, h, delta, R, ell, i, GG,gg,hh,del;
   print(`F = `, F, `G = `, G);
   print(`Fb = `, F mod p, `Gb = `, G mod p);

   U := F mod p; V := G mod p; g := 1; h := 1;
   print(`V = `, V);
   delta := degree(U, x) - degree(V, x);
   print(`delta = `, delta);

   GG[1] := U; GG[2] := V;
   del[1] := degree(GG[1], x)-degree(GG[2], x);
   gg[1] := lcoeff(GG[1], x); gg[2] := lcoeff(GG[2], x); hh[2] := gg[2]^del[1];
   i := 2;

   while( degree(V, x) > j )
   do 

      i := i+1; print(`i = `, i);
      if i<=3 then
         GG[i] := (-1)^(del[i-2]+1)*
                  Rem(gg[i-1]^(del[i-2]+1)*GG[i-2] mod p, GG[i-1], x) mod p;
      else
         GG[i] := (-1)^(del[i-2]+1)/(gg[i-2]*hh[i-2]^del[i-2])*
                  Rem(gg[i-1]^(del[i-2]+1)*GG[i-2] mod p, GG[i-1], x) mod p;
      fi;
      del[i-1] := degree(GG[i-1], x)-degree(GG[i], x);
      gg[i] := lcoeff(GG[i], x);
      hh[i] := gg[i]^del[i-1] * hh[i-1]^(1-del[i-1]) mod p;

      ell := lcoeff(V, x);
      R := Rem(ell^(delta+1)*U mod p, V, x) mod p;
      if (R = 0) then RETURN(0); fi;

      U := V; V := (-1)^(delta+1)* R / (g*h^delta) mod p;

      g := lcoeff(U, x); h := h^(1-delta) * g^delta mod p;
      print(`g = `, g, `h = `, h);
      print(`h/g * U =`, h/g*U mod p);
      delta := degree(U, x) - degree(V, x);
      print(`delta = `, delta);


      print(`gg[i-1]=`, gg[i-1], `hh[i-1]=`, hh[i-1]);
      print(`gg[i]=`, gg[i], `hh[i]=`, hh[i]);

      print(`V=`, V);
      print(`GG=`, GG[i]);
      print(`hh[i]/gg[i]*GG=`, hh[i]/gg[i]*GG[i] mod p);
      print(`subres = `,det(subresmat(F, G, x, degree(V,x))) mod p);
   od;

   g := lcoeff(V, x); h := h^(1-delta) * g^delta mod p;
   print(`g = `, g, `h = `, h);
   if( degree(V, x) = j) then RETURN(h/g*V mod p); fi;
   if( degree(U, x)-1 = j) then RETURN(1 * V); fi;
   RETURN(0);
end;

toedetp := proc(row1, col1, p)
   local i, n, x, Tau, S;
   n := vectdim(row1);
   Tau := 0; x := 'x';
   # compute Tau
   for i from n by -1 to 1 do
       Tau := Tau + col1[i] * x^(n-i) mod p;
   od;
   for i from 2 to n do 
       Tau := Tau + row1[i] * x^(i+n-2) mod p;
   od;
   print( x^(2*n-1) );
   print( Tau );
   S := subresp(x^(2*n-1), Tau, x, n-1, p);
   if( degree(S, x) < n-1 ) then RETURN(0); fi;
   RETURN( lcoeff(S, x) );
end;

subresmat:=proc(G,H,x,j)
   local m, ell, syl, rcol1, rcol2, i;
   m := degree(G, x); ell:=degree(H, x);
   syl := sylvester(G,H,x);
   rcol1 := matrix(ell-j,1);
   for i from 0 to ell-j-1 do rcol1[i+1, 1] := x^(ell-j-1-i)*G; od;
   rcol2 := matrix(m-j,1);
   for i from 0 to m-j-1 do rcol2[i+1, 1] := x^(m-j-1-i)*H; od;
   blockmatrix(2,2,submatrix(syl,1..ell-j,1..ell+m-2*j-1), rcol1,
                   submatrix(syl,ell+1..ell+m-j, 1..ell+m-2*j-1), rcol2);
end;
