#-----------------------------------------------------------------------
# module: det.mpl
#
# author: Angel Diaz
# date: 9/5/96
#
# (c) Copyright 1996 Angel Diaz and Eirch Kaltofen, All Rights Reserved
# This code is provided WITHOUT WARRANTY either expressed or implied.
#-----------------------------------------------------------------------

with(linalg):

#-----------------------------------------------------------------------
# function: fraction_free_elim
# date: 9/5/96
#
# reference: 
#
# description: 
#-----------------------------------------------------------------------

fraction_free_elim := proc(
   A,    # a maple nXm matrix A
   n,
   m 
)
local k,p,tmp, 
      sign,
      divisor,
      r;

   sign    := 1;
   divisor := 1;
   r       := 1;
   
   # eliminate below row r, with pivot in column k
   for k from 1 to n do
      printf(`Column k = %a\n`,k);
      if ( r <= m ) then
         # find a nonzero pivot
         printf(`find a nonzero pivot\n`); 
         for p from r to m do
            if ( A[p,k] <> 0 ) then
               break;
            fi;
         od;
         if ( p <= m ) then
            # pivot is in row p, so switch rows p and r
            printf(`Pivot is in row p = %a\n`,p);
            printf(`Switching rows p = %a and r =%a \n`,p,r);
            for j from k to n do
               tmp := A[p,j];
               A[p,j] := A[r,j]; 
               A[r,j] := tmp;
            od; 
            # keep track of sign changes due to row exchange
            if ( r <> p ) then
               sign := -1*sign;
            fi;
            printf(`Divisor is %a\n`,divisor);
            for i from r+1 to m do
              for j from k+1 to n do
                 A[i,j] := (A[r,k]*A[i,j] - A[r,j]*A[i,k])/divisor;
              od; 
              A[i,k] := 0;
            od;
            divisor := A[r,k]; r := r + 1;
            printf(`Row r = %a\n`,r);
         fi; 
      fi; 
   od; 
   if ( r = m + 1 ) then
      det := sign*divisor;
   else
      det := 0;
   fi;
   printf(`det is %a`,det);
   RETURN(A);
end;

B :=matrix([
[3,4,-2,1,-2],
[1,-1,2,2,7],
[4,-3,4,-3,2],
[-1,1,6,-1,1]
]);

